#ifndef ACTUATOR_H_
#define ACTUATOR_H_

#include <limits.h>
#include <deque>

struct Plan {
    int time;
    int addr;
    double value;
};

class Actuator {
public:
    Actuator() : turn(0), baseTurn(0) {}
    virtual ~Actuator() {}

    int step();
    virtual int arrivalTime() { return INT_MAX; }
    virtual void setGoal(double) {}

    double* out;
    int turn;
    int baseTurn;

    int* inaddr;
    double* invalue;

protected:
    void addPlan(int time, int addr, double value);

    virtual void step_() = 0;

    std::deque<Plan> plans;
};

Actuator* createActuator(int problem, int* inaddr, double* invalue);

#endif
