#!/usr/bin/env ruby

require 'bigdecimal'
require 'bigdecimal/math.rb'

G = BigDecimal::new((6.67428 / 10**11).to_s, 100)
M = BigDecimal::new((6.0 * 10**24).to_s, 100)

# # -6352278.930324
# # 6361717.566142
# CONFIG = [ [[-6557000.0, 0], 42164000.0],
#            [[-6357000.0,6357000.0], 21082000.0],
#            [[-8357000.0, 6922.335359], 28109333.333333],
#            [[7875.215433, -6456995.197536], 38330909.090909, true],
#            #[8990155.6160056497901678085, 21082000.0],
#            ]

scenario = ARGV[0] ? ARGV[0].to_i - 1 : 0
raise if scenario < 0

f = open('log')
f.gets
f.gets
f.gets
r0x = BigDecimal::new(f.gets.split[-1], 100)
r0y = BigDecimal::new(f.gets.split[-1], 100)
r0 = (r0x*r0x + r0y*r0y).sqrt(100)
rt = BigDecimal::new(f.gets.split[-1], 100)

clockcheck = 0
pd = Math.atan2(r0y, r0x)
10.times{
  f.gets
  f.gets
  f.gets
  x = f.gets.split[-1].to_f
  y = f.gets.split[-1].to_f
  f.gets
  d = Math.atan2(y, x)
  if d > pd
    clockcheck += 1
  else
    clockcheck -= 1
  end
}

f.close

clockwise = clockcheck >= 0

#config = CONFIG[scenario]
#if config[0].class == Array
#  r0x = BigDecimal::new(config[0][0].to_s, 100)
#  r0y = BigDecimal::new(config[0][1].to_s, 100)
#  r0 = (r0x*r0x + r0y*r0y).sqrt(100)
#else
#  r0 = BigDecimal::new(config[0].to_s, 100)
#end
#rt = BigDecimal::new(config[1].to_s, 100)

dv0 = (G*M/r0).sqrt(100) * ((2*rt/(r0+rt)).sqrt(100) - 1)
#puts "dv0 = %.29f" % dv0

dvt = (G*M/rt).sqrt(100) * (1 - (2*r0/(r0+rt)).sqrt(100))
#puts "dvt = %.29f" % dvt

t = Math::PI * ((r0+rt)*(r0+rt)*(r0+rt)/8/G/M).sqrt(100)
#puts "t = %.29f" % t

#if config[0].class == Array
  dv0x = r0 == 0.0 ? 0.0 : - dv0 * r0y / r0
  dv0y = r0 == 0.0 ? 0.0 : dv0 * r0x / r0

  dvtx = r0 == 0.0 ? 0.0 : dvt * r0y / r0
  dvty = r0 == 0.0 ? 0.0 : - dvt * r0x / r0

  if clockwise
    dv0x = -dv0x
    dvtx = -dvtx
  end

  s = 1000 + scenario + 1
  puts s

  puts 0
  puts 3
  puts "16000 #{s}"
  puts "2 %.19f" % dv0x
  puts "3 %.19f" % dv0y

  puts 1
  puts 2
  puts "2 %.19f" % 0
  puts "3 %.19f" % 0

  dt = t - t.to_i

  puts t.to_i
  puts 2
  puts "2 %.19f" % (dvtx * (1 - dt))
  puts "3 %.19f" % (dvty * (1 - dt))

  puts t.to_i+1
  puts 2
  puts "2 %.19f" % (dvtx * dt)
  puts "3 %.19f" % (dvty * dt)

  puts t.to_i+2
  puts 2
  puts "2 %.19f" % 0
  puts "3 %.19f" % 0

  puts 30000
  puts 0
#end


