#!/usr/bin/env ruby

require 'bigdecimal'
require 'bigdecimal/math.rb'

G = BigDecimal::new((6.67428 / 10**11).to_s, 100)
M = BigDecimal::new((6.0 * 10**24).to_s, 100)

scenario = ARGV[0] ? ARGV[0].to_i : 1
raise if scenario < 0
#config = CONFIG[scenario]

f = open("200#{scenario}o.txt")
xa = []
ya = []
oxa = []
oya = []
rt = nil
while f.gets
  f.gets
  x = BigDecimal::new(f.gets.split[-1], 100)
  y = BigDecimal::new(f.gets.split[-1], 100)
  xa << x
  ya << y
  ox = x - BigDecimal::new(f.gets.split[-1], 100)
  oy = y - BigDecimal::new(f.gets.split[-1], 100)
  oxa << ox
  oya << oy
  if !rt
    rt = (ox * ox + oy * oy).sqrt(100)
  end
end

r0x = BigDecimal::new(xa[0].to_s, 100)
r0y = BigDecimal::new(ya[0].to_s, 100)
r0 = (r0x*r0x + r0y*r0y).sqrt(100)

#rt = BigDecimal::new(config[1].to_s, 100)

dv0 = (G*M/r0).sqrt(100) * ((2*rt/(r0+rt)).sqrt(100) - 1)
#puts "dv0 = %.29f" % dv0

dvt = (G*M/rt).sqrt(100) * (1 - (2*r0/(r0+rt)).sqrt(100))
#puts "dvt = %.29f" % dvt

t = Math::PI * ((r0+rt)*(r0+rt)*(r0+rt)/8/G/M).sqrt(100)
#puts "t = %.29f" % t

it = t.to_i
dt = t - it

start = 0
while true
  x = -xa[start] * rt / r0
  y = -ya[start] * rt / r0
  ox = oxa[start+it] * (1 - dt) + oxa[start+it+1] * dt
  oy = oya[start+it] * (1 - dt) + oya[start+it+1] * dt

  dx = x - ox
  dy = y - oy
  d = Math.sqrt(dx*dx + dy*dy)
  #STDERR.puts d.to_f
  if d < 10000
    break
  end

  start += 1
end

r0x = xa[start]
r0y = ya[start]

#if config[0].class == Array
  dv0x = r0 == 0.0 ? 0.0 : - dv0 * r0y / r0
  dv0y = r0 == 0.0 ? 0.0 : dv0 * r0x / r0

  dvtx = r0 == 0.0 ? 0.0 : dvt * r0y / r0
  dvty = r0 == 0.0 ? 0.0 : - dvt * r0x / r0

#  if config[2]
#    dv0x = -dv0x
#    dvtx = -dvtx
#  end

  s = 2000 + scenario
  puts s

  puts 0
  puts 1
  puts "16000 #{s}"

  puts start
  puts 2
  puts "2 %.19f" % dv0x
  puts "3 %.19f" % dv0y

  puts start+1
  puts 2
  puts "2 %.19f" % 0
  puts "3 %.19f" % 0

#   puts start + t.to_i
#   puts 2
#   puts "2 %.19f" % (dvtx * (1 - dt))
#   puts "3 %.19f" % (dvty * (1 - dt))

#   puts start + t.to_i+1
#   puts 2
#   puts "2 %.19f" % (dvtx * dt)
#   puts "3 %.19f" % (dvty * dt)

#   puts start + t.to_i+2
#   puts 2
#   puts "2 %.19f" % 0
#   puts "3 %.19f" % 0

  puts 100000
  puts 0
#end

File.open("tmp#{2000+scenario}.rb", 'w') do |f|
  f.puts start + t.to_i
end


