#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <vector>

using namespace std;

int main(int argc, char* argv[]) {
    if (argc <= 1) {
        fprintf(stderr, "argv!\n");
        exit(1);
    }
    double boost = 1.0;
    if (argc > 2) {
        boost = atof(argv[2]);
    }

    vector<double> xs;
    vector<double> ys;
    vector<double> oxs;
    vector<double> oys;
    double x, y, ox, oy;
    while (scanf("%lf%lf%lf%lf",&x,&y,&ox,&oy) == 4) {
        xs.push_back(x);
        ys.push_back(y);
        ox = x - ox;
        oy = y - oy;
        oxs.push_back(ox);
        oys.push_back(oy);
    }

    int t = atoi(argv[1]);
    double x1 = xs[t];
    double y1 = ys[t];
    double x2 = xs[t+1];
    double y2 = ys[t+1];
    double ox1 = oxs[t];
    double oy1 = oys[t];
    double ox2 = oxs[t+1];
    double oy2 = oys[t+1];
    fprintf(stderr, "x=%lf=>%lf y=%lf=>%lf F\n", x1, x2, y1, y2);
    fprintf(stderr, "x=%lf=>%lf y=%lf=>%lf O\n", ox1, ox2, oy1, oy2);
    double vx = x2 - x1;
    double vy = y2 - y1;
    double ovx = ox2 - ox1;
    double ovy = oy2 - oy1;
    fprintf(stderr, "v=(%lf,%lf) ov=(%lf,%lf)\n", vx, vy, ovx, ovy);
    double dvx = ovx - vx;
    double dvy = ovy - vy;
    fprintf(stderr, "dv=(%lf,%lf)\n", dvx, dvy);

    printf("%d\n", t);
    puts("2");
    printf("2 %.19lf\n", -dvx*boost);
    printf("3 %.19lf\n", -dvy*boost);

    printf("%d\n", t + 1);
    puts("2");
    printf("2 %.19lf\n", 0.0);
    printf("3 %.19lf\n", 0.0);
}
