#include <math.h>

#include <vector>

#include "util.h"

using namespace std;

class Simulator4 {
public:
    Simulator4(double x0, double y0, double x1, double y1,
               const vector<double>& mxa0, const vector<double>& mya0, int t,
               double dvx0 = 0, double dvy0 = 0);

    double angle() {
        return atan2(vy, vx);
    }

    double velocity() {
        return dist(vx, vy);
    }

    void step(double dvx = 0, double dvy = 0);

    void future(int n, vector<double>* xa, vector<double>* ya);
    void future(int n, vector<double>* xa, vector<double>* ya,
                vector<double>* vxa, vector<double>* vya);

    void save();
    void restore();

    double x, y;
    double x1, y1;
    double vx, vy;
    double vx1, vy1;
    const vector<double>& mxa;
    const vector<double>& mya;
    int turn1, turn;
};
