#ifndef UTIL_H_
#define UTIL_H_

#include <math.h>
#include <iomanip>

using namespace std;

#define POS(x, y) setiosflags(ios::fixed) << "(" << x << ", " << y << ")"

const double G = 6.67428e-11;
const double M = 6.0e24;
const double MU = G * M;
const double MUm = G * 7.347e22;

inline double dist2(double x, double y) {
    return x * x + y * y;
}

inline double dist(double x, double y) {
    return sqrt(dist2(x, y));
}

inline double sq(double x) {
    return x * x;
}

inline double cube(double x) {
    return x * x * x;
}

inline double sdiv(double x, double y) {
    return y == 0 ? 0.0 : x / y;
}

bool isClockwise(double x0, double y0, double x1, double y1);

inline double normalize(double a) {
    if (a > M_PI) a -= 2 * M_PI;
    if (a <= -M_PI) a += 2 * M_PI;
    return a;
}

inline double addAngle(double a, double da) {
    a += da;
    return normalize(a);
}

#endif  // UTIL_H_
