#include <assert.h>

#include <SDL.h>

#include <gflags/gflags.h>

#include "vis.h"

void putpixel32(SDL_Surface *surface, int x, int y, Uint32 pixel) {
    if (x < 0 || y < 0 || x >= surface->w || y >= surface->h) return;

    int bpp = surface->format->BytesPerPixel;
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;
    *(Uint32 *)p = pixel;
}

Vis::Vis() {
    SDL_Init(SDL_INIT_VIDEO);
    scr = SDL_SetVideoMode(640, 640, 32, SDL_SWSURFACE);
}

Vis::~Vis() {
    SDL_Event ev;
    while (SDL_WaitEvent(&ev)) {
        if (ev.type == SDL_QUIT) {
            break;
        }
        else if (ev.type == SDL_KEYDOWN && ev.key.keysym.sym == SDLK_ESCAPE) {
            break;
        }
        SDL_Flip(scr);
    }

    SDL_Quit();
}

void Vis::draw() {
    turn++;
    draw_();
}

class Vis1 : public Vis {
public:
    virtual void draw_() {
    }
};

Vis* createVis(int problem) {
    assert(problem > 0);
    assert(problem <= 4);
    Vis* vis = 0;
    if (problem == 1) {
        vis = new Vis1();
    }
    return vis;
}

